># <b># VikingsDoSwim</b>

A simple mod that lets you configure Max Swim Speed at max swim skill level. Scales your swim speed, stamina regen and stamina consumption to your swim skill level. Adds a new diving mechanic that lets you swim underwater.

<br/>

>## ## Installation (manual)

- extract `VikingsDoSwim.dll` file to your `BepInEx\Plugins` folder.

<br/>

>## ## Features

- Configurable exp multiplier for swim skill.
- Idle stamina regen base on swim skill.
- Swim speed scaled by swim level.
- Configurable Max Swim Speed at Max Skill Level.
- Diving mechanic that lets you swim underwater.
- Uses ServerSync to sync configs from servers to clients.
- Uses built in config watcher.
- Joystick compatible tested with an xbox360 controller.
- Configurable underwater brightness.
- Configurable underwater fog density.
- Configurable through config file or [configuration manager](https://valheim.thunderstore.io/package/Azumatt/Official_BepInEx_ConfigurationManager/)

<br/>

<details>
<summary><b>How To Dive?</b> (<i>click to expand</i>)</summary>

- While swimming in the water press crouch/sneak key ( left control ) together with forward direction key ( W ) then use mouse to navigate to the direction you want to go.
- ( W + Left Control ) + Mouse.
- While holding W + Left Control you can dive down or up using mouse to navigate.
- If you release Left Control you can swim normally using direction keys ( W A S D ) but you can't dive down or up.
- Diving also uses your stamina so better prepare foods with lots of stamina or stamina potion.
- If you run out of stamina while underwater you'll take damage normally until your hp goes down and you'll die.
- If you run out of stamina or you just want to go back up quickly you can press jump key ( Space ).
- While idle in the water your stamina will naturally regen.

<br/>
</details>
<br/>

>## ## Recommended Mod:
- If you want to use your equipment underwater or while in the water, use my [WieldEquipmentWhileSwimming](https://valheim.thunderstore.io/package/blacks7ar/WieldEquipmentWhileSwimming/) mod.. It supports all kinds of equipments vanilla or modded.

<br/>

>## ## Changelog
<br/>

v1.2.5
- added config for recipe.
- added config option to disable recipe.
- added translations.
- added russian translations (credits to nexusmod user @ashik83 for providing the translation.)

<details>
<summary><b>Changelog History</b> (<i>click to expand</i>)</summary>
<br/>

v1.2.4
- removed item manager.
- added compatibility fixed to krumpacs new water shader.

v1.2.3
- updated to the latest valheim build (217.14) hilders request.

v1.2.2
- fixed an NRE when you die in the middle of the ocean

v1.2.1
- added compatibility support to krumpacs custom waters (you can now dive on his dungeons)
- supports any custom water that uses water volume scripts.

v1.2.0
- fixed fog effect bug with some areas like shores ands swamps.

v1.1.9
- updated to the latest valheim build (216.9)

v1.1.8
- added a new magical crown that you can use to dive longer underwater, it gives the wearers ability to breath underwater or rather a status effect that lets you recover your stamina while underwater xD (as requested in O+ dc)

v1.1.7
- added configurable sprint hotkey (you can now sprint while swimming or diving, sprinting speed is scaled by your swim skill level.)
- you can no longer stay underwater for too long, your stamina will be slowly depleted while underwater.
- some minor bug fixes

v1.1.4
- remove incompatibility tag with rune magic

v1.1.3
- optimized code and updated serversync
- added incompatibility to better diving and rune magic mod to avoid conflict with patching the water surface

v1.1.2
- added version checks
- updated to latest valheim assemblies

v1.1.1
- fixed DOF bug, DOF WILL NO LONGER DEACTIVATES IF YOU HAVE IT ON by default
- changed Fog Effect activation, it will no longer activates in foggy areas like the swamps.

v1.1.0
- added underwater brightness settings.
- added underwater fog density settings.
- added underwater min/max fog density settings.(as requested)

v1.0.9
- added possible fix for dof being forced to turnoff when it is being use as default. (damn my eyes hurt its hard to tell the difference with my test machine)

v1.0.8
- added config option for dive and ascend key
- added joystick compatibility tested with an xbox360 controller (forgot to add this with the last update)

v1.0.7
- fixed errors on dedicated servers running on linux

v1.0.6
- fixed bug that makes your char float in the air after coming out of diving.
- added DOF effect when underwater.

v1.0.5
- Added Config Watcher
- Added new Diving Mechanic

v1.0.1
- added max swim speed configuration
- fix stamina bug when mod is off

v1.0.0 
- first release

</details>